;;;INICOM equ 1
NOT_FOR_AP2     equ 1
;----------------------------------------------------------------------------
; PC-9821B2 IDE BIOS patch Version 5.12 (C) 2024-2025 ܂
;----------------------------------------------------------------------------
MEMseg          equ     6800h   ; < 8000h
IDE_equip       equ     10h     ; IDE BIOS bit
E10_equip       equ     20h     ; E10 BIOS bit(X-mateł͗v)  
SND_equip       equ     80h     ; SND BIOS bit(A-mate,FELLOW)

LOCATION_CHSLBA equ     1D70h   ; Ƃ̂Ɏ܂ȂR[h̊i[ꏊ
LOCATION_LBACHS equ     10F0h   ; ubNXgׂĂ
LOCATION_IDP    equ     1E65h   ; IDE BIOS̋󂫂͎gȂ悤ɂ
LOCATION_FUNC84 equ     10B7h   ; 
MSG_DISP_LINE   equ     13      ; \JnsłBKXĂB
; Global stack variables -----------------
SegTVRAM        equ     word ptr [bp-4] ; T-VRAM̃ZOgA000/E000
ROW             equ     word ptr [bp-6] ; \s
COLUMN          equ     word ptr [bp-8] ; \J
COLOR_ATTRIB    equ     byte ptr [bp-10] ; \F
HiresoFlag      equ     byte ptr [bp-11] ; 01h Hi-reso flag (bit 0)
StartLine       equ     byte ptr [bp-12] ;
WORK05B0        equ     byte ptr [bp-13] ;
equip           equ     byte ptr [bp-14] ; 00h ; Flags of SCSI,IDE,SOUND BIOS existence
ModeID          equ     byte ptr [bp-15] ; ݂̃p[^[h
MemWindowAddr   equ     byte ptr [bp-16] ; 08-BANK window address in EXROM
MachineID       equ     byte ptr [bp-17] ; Machine ID
MemWindowNative equ     byte ptr [bp-18] ; 08-BANK window native address
MachineType     equ     byte ptr [bp-19] ; [1]=Ap2/As2/Af, [2]=B2
SECTOR_N        equ     byte ptr [bp-20] ; 
HEAD_N          equ     byte ptr [bp-21] ; 
mem_bank_IOaddr equ     word ptr [bp-24] ; 0461h/0091h(nC])
SegPhysIDEBIOS  equ     word ptr [bp-26] ; IDE BIOSZOgiIj
SegMMapIDEBIOS  equ     word ptr [bp-28] ; IDE BIOSZOgiRAMmappingj

code            segment public use16
                assume cs:code,ds:code,es:code,ss:code
                org 100h  ; for MS-DOS .COM file
start:
                jmp    program_start
                org 102h
title_msg       DB      0E1h,"IDE BIOS̗eʏgCHSp[^ύX(98ŎgȂ̂gp\)  V5.12",13,10,0
.186
program_start:  
                push    ds
                xor     ax,ax
                mov     ds,ax
                mov     ds:[0000h],offset div0recover
                mov     ds:[0002h],cs
                pop     ds
                enter   36,0
                mov     COLOR_ATTRIB,0E1h
                cld
                call    ResoModeCheck   ; nC]^m[}`FbNT-VRAMZOg擾
                xor     ax,ax           ; AL=0
                mov     equip,al        ; bit̏l
                mov     MachineType,al  ; =0
                
                call    GetSeg_IDEBIOS  ; ^,RAMIDE BIOSZOg𓾂 2018-12-11V
                call    ModelCheckAB2   ; @풲, B2,C2ȊO͒~(A2́H)
                pushf   ; CYtOză^Cg\Ă
                call    GetDisplayLine  ; ITF TEXTʕ\s̐ݒ
                call    DisplayTitle    ; ^Cg\
                popf
                jc      WrongMachine
                cmp     MachineType,0
                jz      WrongMachine

                call    Scan_GRPH_FK    ; 2024-3-25 ǉidlύXj 
                jc      CancelCTRL

                call    CheckMemSwitch  ; XCb`̃[hݒ擾
                jc      ExitProgram     ; CY=G[ŏI
                call    Exist_IDE_BIOS  ; IDE BIOS̑݃`FbN
                jc      ExitProgram     ; CY=G[Œ~

                call    NOPCI_Check     ; PCI BIOS邩HCY
                jc      WrongMachine    ; CYĂ΋@ႢŃG[
                call    PeriEnvCheck    ; 486@ƔfROM`FbN
                jc      WrongMachine    ; CY=G[Œ~

                call    DisplayEquip

                mov     dx,1E8Eh
                mov     al,81h
                out     dx,al
                call    ROMtoMEM        ; IDE BIOS ROMMEMɓ] 8KB

                cmp     MachineType,1   ; Ap2,As2
                je      To_A2_pathch
ifdef   NOT_FOR_AP2
                call    B2_patch        ; B2@̃pb`
                jc      WrongBIOS
ELSE
                call    A2_patch        ; A2@̃pb`
                jc      WrongBIOS
ENDIF
;                call    SetChkSum
                call    MEMtoIDEBIOS    ; ̍ƌʂRAM BIOSɃRs[
                call    ClearMEMseg     ; ƃNAđދ
ExitProgram:
                call    ShiftKeyCheck   ; VtgL[ŕ\ꎞ~

ifdef   INICOM  ; eXgp
                mov     ax,0380h
                int     1Bh
endif
                leave
                RET    ; near ^[ŏI
;-------------------------------------------
WrongMachine:   mov     dx,offset wrong_msg 
                call    _puts   ; ű@ɂ͑ΉĂ܂v\
                jmp     ExitProgram     ; G[ŏI
CancelCTRL:     mov     dx,offset msg_CRLF
                call    _puts
                jmp     AvoidPatch
WrongBIOS:      call    Poop ; ````
                mov     dx,offset wrong_bios    ; uΉBIOSł͂Ȃv
                call    _puts
AvoidPatch:     mov     dx,offset msg_AvoidPatch; u~܂v 
                call    _puts
                jmp     ExitProgram
To_A2_pathch:   mov     dx,offset msg_not_for_A2
                call    _puts
                call    Poop ; ````
                jmp     AvoidPatch

;----------------------------------------------------------------------------
div0recover:
               push     ax
               push     bx
               push     cx
               push     dx
               push     si
               push     di
               push     es

                mov     si,offset div0mes
                mov     cx,offset div0mes_e - offset div0mes
                mov     dx,0061h
                call    DisplayVRAM
               pop      es
               pop      di
               pop      si
               pop      dx
               pop      cx
               pop      bx
               pop      ax

                pop     ax      ; retrive previous stack
                inc     ax      ; 2 byte before the called addresss 
                inc     ax
                push    ax      ; store the adress to stack memory
                mov     dx,0            ; return value of DX:AX is set to
                mov     ax,0FFFFh       ; maximum of 16bit
                iret            ; resume instruction

align 2
;;;ueʏ𒴂fBXNhCuڑĂ܂v
div0mes         label   byte
DW      462Dh,46ADh,4C2Eh,4CAEh,651Eh,659Eh,4218h,4298h,7204h,7284h,3624h
DW      36A4h,2804h,2884h,3F04h,3F84h,4705h,4785h,2305h,2385h,3905h,3985h
DW      2F05h,2F85h,4905h,4985h,6905h,6985h,2405h,2485h,5605h,5685h,2C04h
DW      2C84h,5C20h,5CA0h,3322h,33A2h,3504h,3584h,6C04h,6C84h,4604h,4684h
DW      2404h,2484h,5E04h,5E84h,3904h,3984h
div0mes_e       label   byte
DW      0000h
;---------------------------------------------------------------------
;   DisplayVRAM   cs:si=string pointer,  cx=length, dx=color attribute
;---------------------------------------------------------------------
DisplayVRAM     PROC   near     ; DI=position on T-VRAM
                cld
                shr     cx,1
                xor     ax,ax   ; 
                mov     es,ax
                mov     ah,0E0h
                mov     al,es:[0501h]
                test    al,8
                jnz     @f
                mov     ah,0A0h
        @@:     mov     al,00h
                mov     es,ax
                mov     di,(2*30)+(2*80*24) ; column locatin

DispVramEnt:    mov     ax,cs:[si]
                inc     si
                inc     si
                mov     es:[di+2000h],dx        ; VRAM attribute write
                stosw
               loop     DispVramEnt
                ret
DisplayVRAM     ENDP

;----------------------------------------------------------------------------
title_msg2      DB      0E1h,"@ ",0
machine_typeC2  DB      0E1h,"98Multi PC-9821mCs2,Ce2n ",13,10,0
machine_typeB2  DB      0E1h," Q B2-Fellow, B-Mate  ",13,10,0
machine_typeA2  DB      0E1h,"PC-9821mAp2,As2,Afn ",13,10,0
machine_typeUN  DB      0E1h,"s  ",0
absent_msg      DB      041h,"IDE BIOSoĂ܂ifBXN̐ڑj",13,10,0
wrong_bios      DB     0C1h,"ΉȂBIOSł. ",0
wrong_msg       DB     041h,"̋@ɂ͑Ή܂.",13,10,0
msg_AvoidPatch  DB     0E5h," pb`𒆎~܂. ",13,10,0
msg_CRLF        DB     0E1h," ",13,10,0
msg_div0        DB     0C1h,"DIV0ROM[h[F6]ɐݒ肳Ă̂, EXIDE𒆎~܂.",13,10,0
msg_not_for_A2  DB     041h,"PC-9821Ap2,As2,Afɂ͑Ή܂. ",0

;--------------------------------------------------------
;       machines
;--------------------------------------------------------
include patch_b2.s
;include patch_a2.s

;--------------------------------------------------------
;       MEMtoIDEBIOS    5C00:0-->D800:0
;--------------------------------------------------------
MEMtoIDEBIOS    PROC   near
                pushf
                cli     ; BIOSRAMւ̓]͊荞݋֎~Ƃ
                call    ROMRAM486_IDE   ; ݒALbVtbV
                call    MEMtoROM        ; MEM̃f[^RAMBIOSɃRs[
                call    RAMROM486_IDE   ; sݒALbVtbV
                popf
                ret     ; G[Ԓl͂Ȃ
MEMtoIDEBIOS    ENDP

;--------------------------------------------------------
;       MEMtoROM        5000:0-->ES:0   ES=RAMwindowIDE
;--------------------------------------------------------
MEMtoROM        PROC    near
                cld
                mov     es,SegMMapIDEBIOS
                mov     cx,2000h/2      ; 8KB
                push    cx
                xor     ax,ax
                mov     si,ax
                mov     di,ax
                push    si
                mov     ax,MEMseg
                push    ds
                mov     ds,ax   ; ds=MEMseg, es=IDE BIOSRAMwindow
           rep  movsw
                pop     ds
                pop     si
                pop     cx
                ret
MEMtoROM        ENDP

;--------------------------------------------------------
;       ROMtoMEM        ds=D800:0-->5000:0
;--------------------------------------------------------
ROMtoMEM        PROC    near
                cld
                mov     cx,2000h/2      ; 8KB
                xor     ax,ax
                mov     si,ax
                mov     di,ax
                mov     ax,MEMseg
                push    es
                push    ds
                mov     es,ax   ; ES=AX=MEMseg
                mov     ds,SegPhysIDEBIOS   ; DXɐ^IDE BIOS̃ZOg
          rep   movsw
                pop     ds
                pop     es
                ret
ROMtoMEM        ENDP

;--------------------------------------------------------
;       ROMRAM486_IDE  (ex)     A-mate
;--------------------------------------------------------
ROMRAM486_IDE   PROC    near
                mov     dx,043Fh ;
                mov     al,0A0h   ; clear cache
                out     dx,al
                mov     dx,mem_bank_IOaddr      ; 8-9 bank selected to
                mov     al,MemWindowAddr        ; address C000 or E000h.
                out     dx,al
                mov     dx,053Dh ; 053D_mem_enabler_switch
                mov     al,02h   ; RAM window access enable =bit2=0
                or      al,equip ; Internal IDE,SCSI,SND BIOS enable
                out     dx,al
                ret
ROMRAM486_IDE   ENDP
;--------------------------------------------------------
RAMROM486_IDE   PROC    near
                mov     dx,mem_bank_IOaddr      ; 8-9 bank selected to
                mov     al,MemWindowNative      ; address 8000h or 10000h
                out     dx,al
                mov     dx,053Dh ; 053D_mem_enabler_switch
                mov     al,06h   ; RAM window access disable =bit2=1
                or      al,equip ; Internal IDE,SCSI,SND BIOS enable
                out     dx,al
                mov     dx,043Fh ;
                mov     al,0A0h  ; Invalidate CPU cache
                out     dx,al
                ret
RAMROM486_IDE   ENDP

;------------------------------------------------------------
;       ModelCheckAB2
;------------------------------------------------------------
ModelCheckAB2   PROC   near
                mov     al,MachineID
                cmp     al,07h  ; Bp,Bs,Be,PC-9801 BX2,BA2
                je      Machine_B2
                cmp     al,08h  ; Ce2,Cs2
                je      Machine_C2
                cmp     al,05h ; Ap2,As2      ; <====05 
                je      Machine_A2
                cmp     al,06h ; Af
                je      Machine_A2
                mov     MachineType,0
                stc
                ret
Machine_C2:     mov     MachineType,4   ; 4=Cs2,Ce2
                clc
                ret
Machine_B2:     mov     MachineType,2   ; 2=B2
                clc
                ret
Machine_A2:     mov     MachineType,1   ; Af,Ap2,As2
                clc
                ret
ModelCheckAB2   ENDP

;------------------------------
include ideptcom.inc
include numeric.inc     ; l\[`
include e:\asmlib\putstrCS.inc      ; \[`i\[X͕t܂j
;-----------------------------------------
.386
PatPtn2_LBA_CHS    label word      ; offset 0A66h
                mov     si,2080h
                test    byte ptr [bp+00h],01h
                jz      @f
                mov     si,2090h
        @@:     
                push    ax
                mov     ax,es:[si+0Ah]  ; ZN^ ,wbh
                mul     ah
                mov     cx,ax           ; ZN^*wbh=CX
                pop     ax              ; DX:AX

                div     cx
                mov     es:[2002h],ax
                mov     ax,dx
                mov     cl,es:[si+0Ah]
                mov     ch,0
                mov     dx,0
                RET
PatPtn2_LBA_CHS_end  label word
;--------------------------------------
.186
;--------------------------------------
;  W    [2082h]    CylnN(BIOS,logical)
;  B    [208Ah]    SectN(device,physical)
;  B    [208Bh]    HeadN(device,physical)
;          9
;  B    [208Eh]    SectN(BIOS,logical)
;  B    [208Fh]    HeadN(BIOS,logical)

PatPtn2_IDP     label word      ; offset 1DC0
                test    byte ptr [bp+00h],01h
                jz      Drive00
Drive01:        mov     byte ptr ah,es:[2090h+0Bh]
                dec     ah      ;phys head-1
                and     al,07h
                cmp     al,04h
                jmp     LAB_39A
Drive00:        mov     byte ptr ah,es:[2080h+0Bh]
                dec     ah      ;phys head-1
                and     al,38h
                cmp     al,20h
LAB_39A:
                jnz     LAB_3A5
                or      byte ptr es:[2004h],ah
                jmp     LAB_3AB
                nop
LAB_3A5:
                or      byte ptr es:[2004h],ah
LAB_3AB:
                RET
PatPtn2_IDP_end  label word
;----------------------------------
PatPtn2_Func84  label word      ; offset 03E1h
                push    ax
                mov     si,2080h
                test    byte ptr [bp+00],01h
                jz      @f
                mov     si,2090h
        @@:
                mov     al,es:[si+0Eh]  ; S
                mov     [bp+06h],al
                mov     al,es:[si+0Fh]  ; H
                mov     [bp+07h],al
                mov     dx,es:[si+02h]  ; C
                mov     [bp+04h],dx
                pop     ax
                ret
PatPtn2_Func84_end  label word

;----------------------------------
code    ends
        end     start
