;--------------------------------------------------------------+-----------+
;       Scan_GRPH_FK  [FE1]`[FE7]L[Ń[hIEL   | 2024/11/13|
; L[Ԃ݂    keycode   e[h̊OlɑΉ |           |
;--------------------------------------------------------------+-----------+
Scan_GRPH_FK   PROC   near
                mov     cx,7777
        @@:     mov     ah,2
                int 18h
                test    al,00001000b    ; 1=SHIFT, 8=GRPH
                jnz     EnterValue
                test    al,00010000b    ; 16=CTRL
                jnz     CancelProgram
               loop     @b
                jmp     ScanFKEY_abort
EnterValue:     
                call    FnKeyMenu
                call    Poop            ; ````
                xor     ax,ax   ; wait while keybord input 
                int 18h         ; return: AL=key DATA, AH=key CODE
                mov     dx,offset Clear80
                call    _puts
                dec     ROW
                mov     dx,offset Clear80
                call    _puts
                dec     ROW
                dec     ROW
                xchg    al,ah   ; with key CODE
                or      al,al   ; key code 00h=[ESC] ,AL=0
                jz      CancelProgram

                cmp     al,62h  ; key Code 62h=[F.1] 
                jb      EnterValue
                cmp     al,67h  ; key Code 67h=[F.6]
                ja      EnterValue
                sub     al,61h          ; -61hOlƂȂ
                and     al,00000111b    ; Mask for safety
                mov     ModeID,al       ; [hlm肷
                
                push    ax
                mov     al,0Dh          ; XCb`\ɂ
                out 68h,al
                pop     ax
                call    Poop            ; ````
                call    Peee            ; ````

                mov     COLUMN,0        ; JOɂ
                mov     bx,3FF6h        ; XCb`U
                mov     ah,es:[bx]      ; XCb`Uǂݍ
                and     ah,11111000b    ; ̃rbgۑ̃}XN
                or      al,ah
                mov     es:[bx],al      ; XCb`Uɏ
                mov     al,0Ch          ; XCb`֎~ɂ
                out 68h,al
ScanFKEY_abort:
                mov     al,ModeID
                clc
                ret
Div0Only:
CancelProgram:  mov     al,7
                stc
                ret
Clear80         DB     0E1h,"                                                                                ",0
Scan_GRPH_FK   ENDP


;---------------------------------------
FnKeyMenu       PROC   near
;                inc     ROW     ; Psi߂ĕ\
                mov     COLUMN,0
                mov     dx,offset EnterModeValue
                call    _puts
                mov     dx,offset FnKey1  
                call    _puts
                mov     dx,offset ModeEx1 
                call    _puts
                mov     dx,offset FnKey2  
                call    _puts
                mov     dx,offset ModeEx2 
                call    _puts
                mov     dx,offset FnKey3  
                call    _puts
                mov     dx,offset ModeEx3 
                call    _puts
                mov     dx,offset FnKey4  
                call    _puts
                mov     dx,offset ModeEx4 
                call    _puts
                mov     dx,offset FnKey6  
                call    _puts
                mov     dx,offset ModeEx6 
                call    _puts
;                mov     dx,offset msg_CRLF
;                call    _puts
                ret
EnterModeValue  DB     0E3h,"HSҰ ӰށI[n]",13,10,0
FnKey1          DB     0E5h,"P",0
ModeEx1         DB     0A1h,"IDEgCF/SSD,  ",0
FnKey2          DB     0E5h,"Q",0
ModeEx2         DB     081h,"IDEgHD,  ",0
FnKey3          DB     0E5h,"R",0
ModeEx3         DB     0A1h,"SCSI݊CF/SSD,  ",0
FnKey4          DB     0E5h,"S",0
ModeEx4         DB     081h,"SCSI݊HD, ",0
FnKey6          DB     0E5h,"U",0
ModeEx6         DB     0E1h,"div0ROM",0
FnKeyMenu       ENDP



;----------------------------------------------------------------
CheckMemSwitch  PROC   near
; XCb`̐ݒ݂
                mov     es,SegTVRAM
                mov     al,es:[3FF6h]   ; XCb`U̎w
                and     al,00000111b    ; }XN
                or      al,al           ; XCb`ÔƂftHg
                jnz     ValidMEMSW
                mov     al,1            ; default=1
ValidMEMSW:     mov     ModeID,al       ; XCb`gpȂ炻ɏ]
                mov     bl,al
                cmp     bl,6            ; l>=6ȂLZ
                jb      @f
                
                mov     dx,offset msg_div0
                call    _puts
                stc
                ret
        @@:
                shl     bl,1    ; *2{
                mov     bh,0    ; AhXItZbg
                add     bx,offset ModeNamePtr
                mov     dx,[bx] ; \
                call    _puts
                mov     dx,offset Clear80
               call    _puts
                clc
                ret

ModeNamePtr     DW      offset  Mode1Name
                DW      offset  Mode1Name
                DW      offset  Mode2Name
                DW      offset  Mode3Name
                DW      offset  Mode4Name
                DW      offset  Mode5Name
                DW      offset  Mode6Name
Mode1Name       DB      0E1h,"CF,SSFœK[h(4351MBȉ H:S  _8:17, 16:63 )",13,10,0
Mode2Name       DB      0E1h,"HD݊[h(4351MBȉ H:S  8:17, _EƂ)",13,10,0
Mode3Name       DB      0E1h,"SCSI݊[h(CF,SSFœK) _H:S  8:32, 8GBȏ 8:128 )",13,10,0
Mode4Name       DB      0E1h,"SCSI݊[h(HDœK) H:S  8:32, 8GBȏ 8:128 _EƂ)",13,10,0
Mode5Name       DB      0E1h,"SCSI݊[h(HDœK) 8:32, 8GBȏ 8:128 , 32GBȏ 15:128)",13,10,0
Mode6Name       DB      0E1h,"DIV0ROM@\̂",13,10,0
ModeXName       DB      041h,"[h`Agps",13,10,0
CheckMemSwitch  ENDP

;--------------------------------------------------------
;       SetTone         
;--------------------------------------------------------
SetTone         PROC   near             ; ax= tone
                push    dx
                mov     DX,03FDBh       ; 3FDB
                out     DX,AL
                out     5Fh,al
                xchg    AL,AH
                out     DX,AL
                out     5Fh,al
                pop     dx
                ret
SetTone         ENDP

;--------------------------------------------------------
;       GetDisplayLine       input   ES = VRAM segment
;--------------------------------------------------------
GetDisplayLine  PROC    near
                xor     ax,ax
                mov     COLUMN,ax
                mov     ROW,MSG_DISP_LINE
                mov     bx,3FE0h                ; ITF\sǗAhX
                mov     al,es:[bx]
                cmp     al,MSG_DISP_LINE
                ja      LineIndicatorInvalid
                inc     ax
                mov     ROW,ax
                add     ax,3
                mov     es:[bx],al
LineIndicatorInvalid:
                mov     ax,ROW
                mov     StartLine,al
                ret
GetDisplayLine  ENDP

;----------------------------------------------------------------
;       PeriEnvCheck ( equiped peripherals ) Ap3,As3,BA3,BX3 only
; port F0h      1= HDD/IF Ȃ ,  0=HDD/IF  _
; bit 6: ^Cv(SCSI)HDDXe[^X            40h 
; bit 5: ^Cv(SASI,IDE)HDDXe[^X        20h
;I/O  00F0h   }VXe[^Xǂݏo^CPUVbg_E
;bit 7: CPUx聡[PC-9821ApAsAeAf]  1=High or Low, 0=Middle
;bit 6: ^Cv(SCSI)HDDXe[^X 1= 55^CvHDDȂ
;bit 5: ^Cv(IDE)HDDXe[^X 1= IDE HDDȂ
;bit 3: RAMANZX 1= W܂͊gXbg

;I/O  841Fh   DIP SWITCHǂݏo
;bit 1: SOUND BIOS   1=use SOUND BIOS  ,  0=release SOUND BIOS
;I/O  8F1Eh   DIP SWITCHǂݏo
;bit 0: 15-16MBԃVXegpL  0=system use  1=RAM use
;align 16
;----------------------------------------------------------------
PeriEnvCheck    PROC    near
                in      al,0F0h
                test    al,20h          ; Internal SASI/IDE exist?
;                jnz     noequip_ide    ; ̃vOIDE BIOS݂Ȃ
;                jnz     IDE_absent     ; Ƃ̂͂蓾.
                OR      equip,IDE_equip ; IDE BIOS o
noequip_ide:    
IF 0    ; SCSI@ł͗LɂȂ
                test    al,40h          ; SCSI(A-mate)݂͑邩?
                jnz     noequip_E10_FA02        ; 2019-1-21
;                cmp     MachineType,*   ; B,Xe,Xs,XpI/O F0 flag bit6̈Ӗ
;                je      noequip_E10_FA02   ; Ⴄ悤Ȃ̂Œ!!
                OR      equip,E10_equip ; SCSI BIOS L
ENDIF
noequip_E10_FA02:
                test    HiresoFlag,1    ; nC]Ȃ疳
                jnz     noequip_sndbios ; SOUND BIOS݂͑ȂƂ
IF 1    ; B2ł̓TEh݂ȂL ; SDIPSWɂ@iA-matesj
                mov     dx,841Eh        ; DIP switch 𒲂ׂɍs@g
                in      al,dx
                test    al,02h          ; bit 1: Undoc2 ƈႤ̂Œ
                jz      noequip_sndbios ; Ap,As,Aeł͕ʂ̌o@I
                or      equip,SND_equip ; TEhBIOSL
ENDIF
IF 0    ; ROM̃f[^`FbNɂ@
                ;iėp͂邪RAMROM̔ʂ͂łȂ̂ł悭Ȃj
                mov     ax,0CC00h
                push    es
                mov     es,ax
                mov     eax,es:[0]
                pop     es
                cmp     eax,0FFFFFFFFh  ; LROM/RAMH
                je      equip_sndbios_e
                or      eax,eax         ; 0Ŗ܂ĂRAM(UMB)
                jz      equip_sndbios_e ; ɂĂLROM͂Ȃ
                or      equip,SND_equip ;
ENDIF
IF 0    ; A-mateL̕sVXeɂ@ 2024/4/8 
                mov     dx,046Ch
                in      al,dx
                cmp     al,0FFh
                je      No_amate1_sound_bios
                mov     al,02h
                out     dx,al
                mov     dx,0468h
                in      al,dx
                in      al,dx
                in      al,dx
                in      al,dx
                in      al,dx   ; KTAœǂݏo
                test    al,1    ; SOUND BIOSLbit 0, ڑtL bit 2
                jz      equip_sndbios_e ; SOUND BIOSL
                or      equip,SND_equip ;
No_amate1_sound_bios:
ENDIF
equip_sndbios_e: 
noequip_sndbios:  ; ROMAvȂ̂SASI BIOSׂ͒ȂiDISKڑUNITgp֎~j
                clc
                ret
IDE_absent:     stc
                ret
PeriEnvCheck    ENDP



;--------------------------------------------------------
;       Exist_IDE_BIOS
;--------------------------------------------------------
Exist_IDE_BIOS  PROC   near
                push    es
                mov     es,SegPhysIDEBIOS
                mov     ax,es:[0009h]   ; ? C-BUS ROM
                mov     bx,es:[000Bh]   ; ? C-BUS ROM
                mov     dx,es:[0030h]  ; ? $PnP
                pop     es
                cmp     ax,0AA55h       ; C-BUS ROM signature
                jnz     NoExist_IDE_BIOS
                cmp     bl,2Ah          ; C-BUS ROM type ID
                jnz     NoExist_IDE_BIOS

                or      dx,dx         ; jmp [0030] == 00000000h
                jz      NoExist_IDE_BIOS
;                mov     dx,offset IDE_msg ; uIDE BIOS܂v
;                call    _puts
                clc
                ret
NoExist_IDE_BIOS:  
                mov     dx,offset absent_msg
                call    _puts
                stc
                ret
Exist_IDE_BIOS  ENDP

;---------------------------------------------------------------------
;       Get segment address of IDE BIOS   ɂP񂾂R[
;---------------------------------------------------------------------
GetSeg_IDEBIOS  PROC    near
                xor     ax,ax
                push    ds
                mov     ds,ax
                mov     al,ds:[0457h]
                mov     ah,ds:[05B0h]
                pop     ds
;;;;;;;;;;;;    mov     WORK0457,al
                mov     WORK05B0,ah
                mov     al,HiresoFlag
                test    al,1        ; --- Normal mode ---
                mov     cx,0DA00h   ; IDE work address (physical)
                mov     dx,0D800h   ; IDE BIOS address (physical)
                mov     ax,09800h   ; IDE BIOS address of memory window
                jz      NormalMode_IDE
                mov     cx,0E800h   ; IDE work address (physical)
                mov     bx,0E600h   ; IDE BIOS address (physical),ordinary
                mov     dx,063Dh
                in      al,dx
                test    al,2
                jz      @f
;;;             add     OffsetXcode,2000h       ; using adapter 
                mov     cx,0EA00h   ; IDE work address (physical)
        @@:     mov     dx,bx       ; 
                sub     bx,6000h    ; phisycal --> shadow
                mov     ax,bx       ; IDE BIOS address of memory window
NormalMode_IDE: mov     SegPhysIDEBIOS,dx
;                mov     SegPhysIDEwork,cx
                mov     SegMMapIDEBIOS,ax
;                mov     es,ax
                ret
GetSeg_IDEBIOS  ENDP

;--------------------------------------------------------------------
;       scan_pattern     ̔r[`  for IDE BIOS (type 2)
;       <input>
;       DS:SI rp^[,         CX p^[̃oCg
;       ES:DI p^[ꏊ,         DX ͈̔̓oCg
;       <output>        < j AX,BX,CX,DX,DI >
;       CY =NONE ,  NC= ES:BX   carry0̂Ƃ  ES:BXɌoꏊԂ
;--------------------------------------------------------------------
scan_pattern    PROC    near
                cld
                mov     di,0030h
                sub     cx,si   ;<-------- type 2
                mov     dx,2000h-30h
                sub     dx,cx   ;<-------- type 2

                xor     bx,bx
                add     dx,di
scan_ent:       mov     ax,ds:[si]
                cmp     ax,es:[di]
                jnz     scan_No_match

                mov     bx,di
                push    cx
                push    si
                push    di
         repz   cmpsb
                or      cx,cx
                pop     di
                pop     si
                pop     cx
                jnz     scan_No_match
                clc                     ; scan OK
                ret
scan_No_match:  inc     di
                cmp     di,dx
                jb      scan_ent
                stc                     ; scan NG
                ret
scan_pattern    ENDP

;---------------------------------------------------------
;       Beep Tone98Set
;---------------------------------------------------------
Tone98Set       PROC    near
                push    dx
                mov DX,03FDBh        ; 3FDB
                out DX,AL
                out     5Fh,al
               xchg AL,AH
                out DX,AL
                out     5Fh,al
                pop     dx
                ret
Tone98Set       ENDP
;--------------------------------------------------------
;--------------------------------------------------------
BeepSound       PROC   near
                call    Tone98Set
                mov     al,6            ; BEEP ON
                out 37h,al              
                mov     cx,bx
        @@:     out     5Fh,al  ; ҂
                out     5Fh,al
               loop     @b
                mov     al,7            ; BEEP OFF
                out 37h,al              
                mov     ax,04CDh        ; normal freq.
                call    Tone98Set
                ret
BeepSound       ENDP
;--------------------------------------------------------
;       Poop
;--------------------------------------------------------
Poop            PROC   near
                push    ax
                push    dx
                push    cx
                push    bx
                mov     ax,4000
                mov     bx,6543h 
                call    BeepSound
                pop     bx
                pop     cx
                pop     dx
                pop     ax
                ret
Poop            ENDP
;--------------------------------------------------------
;       Peee
;--------------------------------------------------------
Peee            PROC   near
                push    ax
                push    dx
                push    cx
                push    bx
                mov     ax,3000
                mov     bx,0FFF0h 
                call    BeepSound
                pop     bx
                pop     cx
                pop     dx
                pop     ax
                ret
Peee            ENDP

;--------------------------------------------------------
;       ClearMEMseg
;--------------------------------------------------------
ClearMEMseg     PROC    near
                push    es
                mov     cx,2000h/2
                mov     ax,MEMseg
                mov     es,ax
                xor     ax,ax
                mov     di,ax
           rep  stosw
                pop     es
                ret
ClearMEMseg     ENDP

;--------------------------------------------
;       DisplayEquip    
;--------------------------------------------
DisplayEquip    PROC   near
                push    ROW
                push    COLUMN
                mov     al,StartLine
                mov     ah,0
                inc     ax
                mov     ROW,ax
                mov     COLUMN,68
                mov     dx,offset msg_equip1
                call    _puts
                inc     ROW
                mov     COLUMN,69
                mov     dx,offset msg_equip2
                call    _puts

                mov     cl,4
                mov     ah,0
                mov     al,equip ; Internal IDE,SCSI,SND BIOS enable
                shr     al,cl
                call    digitbit
                mov     dx,offset msg_b_CRLF
                call    _puts
                pop     COLUMN
                pop     ROW
                ret
DisplayEquip    ENDP
msg_b_CRLF      DB     0E1h,"b",13,10,0
msg_equip1      DB     0E1h," BIOS  ",0
msg_equip2      DB     0E1h,"׸ ",0

;------------------------------------------------------------
;       ResoModeCheck   ŏɂP񂾂Ăяo`FbN
;------------------------------------------------------------
ResoModeCheck   PROC    near
                mov     MemWindowAddr,0Ch
                mov     MemWindowNative,08h
                mov     mem_bank_IOaddr,0461h
                xor     ax,ax
                mov     es,ax
                mov     al,es:[0501h]           ; hi-reso check
                and     al,8    ; 1000b           1      0
                shr     al,2    ;   10b                  0
                add     MemWindowAddr,al        ; 0Eh    0Ch
                shr     al,1    ;    1b
                mov     HiresoFlag,al            ; high/low mode flag
                mov     dx,0A000h       ; Text VRAMZOg
                mov     bx,0F8E8h       ; Machine ID i[ZOg(BIOS)
                mov     ah,00h          ; AH bit 7MAchine ID̈ꕔɎg
                or      al,al
                jz      NormalResoMode  
; HIRESOLUTION MODE SETTINGS
                mov     mem_bank_IOaddr,0091h ; Hireso mem-window port
                mov     MemWindowNative,10h;  Hireso mem-window native addr
                mov     dx,0E000h       ; The segment of Text VRAM at H mode
                mov     bx,0FFE8h       ; The segment of Machine ID flag at H.
                mov     ah,80h          ; bit7=1 , Machine IDmnC]rbg
NormalResoMode: mov     es,dx           
                mov     SegTVRAM,dx     ; TEXT VRAMZOgLϐɊi[
                push    ds
                mov     ds,bx
                mov     al,ds:[003Fh]
                pop     ds
                or      al,ah           ; nC]bitƍ
                mov     MachineID,al
                ret
ResoModeCheck   ENDP

;--------------------------------------------------------
;       DisplayTitle  ( Aps/As3/BA3/BX3/486X-matep )
;--------------------------------------------------------
DisplayTitle    PROC    near
                push    ROW
                push    COLUMN
                mov     ROW,0
                mov     COLUMN,62-4
                mov     dx,offset location_msg
                call    _puts
                mov     ax,cs:[00F8h]
                call    digitx
                pop     COLUMN
                pop     ROW

                mov     dx,offset title_msg
                call    _puts
                mov     dx,offset title_msg2
                call    _puts
                mov     al,MachineType

                cmp     al,4
                je      MachineTypeC2
                cmp     al,2
                je      MachineTypeB2
                cmp     al,1
                je      MachineTypeA2
                mov     dx,offset machine_typeUN
                jmp     @f
MachineTypeA2:  mov     dx,offset machine_typeA2
                jmp     @f
MachineTypeC2:  mov     dx,offset machine_typeC2
                jmp     @f
MachineTypeB2:   mov     dx,offset machine_typeB2
                jmp     @f
        @@:     call    _puts
;                mov     dx,offset CRLF_msg
;                call    _puts
                clc
                ret
DisplayTitle    ENDP

location_msg    DB      0E1h,"EXIDE ROM =",0

;--------------------------------------------------------
;       NOPCI_Check
;--------------------------------------------------------
NOPCI_Check     PROC    near
                xor     dx,dx
                mov     ax,0B101h       ; Get PCI BIOS status
                int     1Ah             ; PCI BIOS call
                jc      PCI_Check_fail
                cmp     dx,20494350h    ; ?dx=='PCI '
                jnz     PCI_Check_fail
                STC
                ret
PCI_Check_fail: CLC
                ret
NOPCI_Check     ENDP

;--------------------------------------------------------
;       ShiftKeyCheck
;--------------------------------------------------------
ShiftKeyCheck   PROC    near
LoopPressShift: mov     ah,02h
                int 18h
                test    al,00011001b    ; 1=SHIFT, 8=GRPH, 16=CTRL
                jnz     LoopPressShift
                ret
ShiftKeyCheck   ENDP

IF 0
;--------------------------------------------------------
;       SetChkSum        ES:0   ES=RAMwindowIDE
;--------------------------------------------------------
SetChkSum       PROC    near
                mov     ax,MEMseg
                push    ds
                mov     ds,ax
                xor     dx,dx
                mov     si,dx
                mov     cx,(2000h/2)
                dec     cx
        @@:
                lodsw
                add     dl,al
                add     dh,ah
               loop     @b
                neg     dl
                neg     dh
                mov     ds:[si],dx
                pop     ds
                ret
SetChkSum       ENDP
ENDIF

