A2_patch        PROC    near
                mov     ax,MEMseg
                mov     es,ax   ; esƗp ES=MEMseg, DS=CS ۏ

; [1] IDP[` (Physical H:S)
                mov     si,offset CodePtn_IDP_A2
                mov     cx,offset CodePtn_IDP_A2_end
                call    scan_pattern
                jc      BIOS_A2_not_found
                mov     ax,bx
                call    digitx
                mov     di,bx
                mov     si,offset PatPtn_IDP_A2   
                mov     cx,offset PatPtn_IDP_A2_end
                sub     cx,si
        rep     movsb

; [2] FUNC84 zpb`(03DCh`)
                mov     si,offset CodePtn_Func84
                mov     cx,offset CodePtn_Func84_end
                call    scan_pattern
                jc      BIOS_A2_not_found
                mov     ax,bx
                call    digitx

                mov     si,offset PatPtn_Func84
                mov     cx,offset PatPtn_Func84_end
                mov     di,bx
        rep     movsb


; [3] CHS-->LBAϊ[` ;  2025/2/15 (Logical H:S, Physical H:S)
                clc
                mov     si,offset CodePtn_CHSLBA_A2
                mov     cx,offset CodePtn_CHSLBA_A2_end
                call    scan_pattern
int 3
                jc      BIOS_A2_not_found
                mov     di,bx
                mov     si,offset PatPtn_CHSLBA_A2
                mov     cx,offset PatPtn_CHSLBA_A2_end 
                sub     cx,si
           rep  movsb

; [4] LBA-->CHSϊASł̈zpb` 2025/2/16 A66(Bp2) , 824(Ap2)
                mov     si,offset CodePtn_LBA_CHS_A2
                mov     cx,offset CodePtn_LBA_CHS_A2_end
                call    scan_pattern
                jc      BIOS_A2_not_found
                mov     di,bx
                mov     si,offset PatPtn1_LBA_CHS
                mov     cx,offset PatPtn1_LBA_CHS_end
                sub     cx,si
        rep     movsb
                mov     di,LOCATION_LBACHS
                mov     si,offset PatPtn2_LBA_CHS
                mov     cx,offset PatPtn2_LBA_CHS_end
                sub     cx,si
        rep     movsb



;[5] eʕٕʂsƂ ŏHS
                mov     si,offset DiscriminateCapa
                mov     cx,offset DiscriminateCapa_END
                call    scan_pattern
                jc      BIOS_not_found
                mov     di,bx
                mov     si,offset Patch_DiscriminateCapaA2
                mov     cx,offset Patch_DiscriminateCapaA2_END
                sub     cx,si
        rep     movsb
        

        ; Copy  Mode ID to IDE WK
                mov     al,ModeID
                mov     es:[0007h],al

BIOS_A2_found:
                clc
                ret
BIOS_A2_not_found: mov     al,0
                stc
                ret
A2_patch        ENDP
;----------------------------------------------
;------------------ CHS-->LBA --------------------
CodePtn_CHSLBA_A2   label word  ; 07E4
        DB      0F6h,46h,00h,80h        ;test    byte ptr [bp+00],80
        DB      75h,0Ah                 ;jnz     07F4
        DB      0B6h,00h                ;mov     dh,00
CodePtn_CHSLBA_A2_end   label word
        DB      8Ah,56h,06h             ;mov     dl,[bp+06]
        DB      8Bh,46h,04h             ;mov     ax,[bp+04]
        DB      0EBh,2Fh                ;jmp     0823
        DB      0B4h,00h                ;mov     ah,00  ; (7FAh)
        DB      06h                     ;push    es
        DB      0Eh                     ;push    cs
        DB      07h                     ;pop     es
        DB      26h,8Ah,47h,03h         ;mov     al,es:[bx+03]
        DB      07h                     ;pop     es
        DB      8Bh,4Eh,04h             ;mov     cx,[bp+04]
        DB      0F7h,0E1h               ;mul     cx
        DB      02h,46h,07h             ;add     al,[bp+07]
        DB      80h,0D4h,00h            ;adc     ah,00
        DB      8Bh,0D0h                ;mov     dx,ax
        DB      0B9h,21h,00h            ;mov     cx,0021

;       DB      0E8h,65h,0FFh           ;call    0776
;       DB      74h,03h                 ;jz      0816
;       DB      0B9h,11h,00h            ;mov     cx,0011
;       DB      8Bh,0C2h                ;mov     ax,dx
;       DB      0F7h,0E1h               ;mul     cx
;       DB      02h,46h,06h             ;add     al,[bp+06]
;       DB      80h,0D4h,00h            ;adc     ah,00
;       DB      83h,0D2h,00h            ;adc     dx,+00
;       DB      0C3h                    ;ret     (823h)



;----------------------------------------------
;----------------------------------------------
PatPtn1_IDP_A2          label   word    ; offset 02D3h
                mov     word ptr es:[2000h],0007h
                mov     ax,es:[208Ah]           ; AL=sect AH=head
                mov     byte ptr es:[200Ah],al  ; sect
                mov     al,[bp+00h]
                and     al,0Fh
                shl     al,04h
                mov     es:[2004h],al           ; dev/H reg.
                nop     
                nop     
                nop     
                nop     
                nop     
                nop     
                mov     al,ds:[0457h]
                and     al,38h
                cmp     al,20h
                DB      75h,09h         ; jnz     0303h
                or      byte ptr es:[2004h],AH  ; AH=Head
                DB      0EBh,07h        ; jmp     0309h
                or      byte ptr es:[2004h],AH
PatPtn1_IDP_A2_end      label word


;===========================================================================
; ZN^l
CodePtn_LBA_CHS_A2    label word
                DB      51h             ;push    cx
                DB      0B9h,11h,00h    ;mov     cx,0011 ;  <-- 3Fh $$$
CodePtn_LBA_CHS_A2_end   label word
                DB      0F7h,0F1h       ;div     cx    ; ZN^Ŋ邩
                DB      0FEh,0C2h       ;inc     dl
                DB      26h,88h,16h,05h,20h   ;mov     es:[2005],dl  ; ZN^ԍni]+Pj
                DB      0BAh,00h,00h    ;mov     dx,0000
                DB      0B5h,00h        ;mov     ch,00
                DB      06h             ;push    es    ; Ă悢 CS:ɂ΂nj
                DB      0Eh             ;push    cs
                DB      07h             ;pop     es
                DB      26h,8Ah,4Fh,02h ;mov     cl,es:[bx+02] ; wbh8 ; BXBF1?  [R]
                DB      07h             ;pop     es
                DB      0F7h,0F1h       ;div     cx
                DB  26h,80h,26h,04h,20h,0F0h    ;and     byte ptr es:[2004_wbhԍ],F0
                DB      26h,08h,16h,04h,20h     ;or      es:[2004_wbhԍ],dl  ; wbhԍn
                DB      26h,0A3h,02h,20h        ;mov     es:[2002],ax  ; V_ԍn
                DB      59h                     ;pop     cx
                DB      26h,88h,0Eh,0Ah,20h     ;mov     es:[200A],cl  ; ĂoCg
                DB      0C3h                    ;ret

Patch_DiscriminateCapaA2    label word
                mov     al,es:[230Ch+1]   ;S      63
                mov     ah,es:[2306h+1]   ;H      16
                mov     es:[208Ah],ax  ; D800:208A=SECTN(PHY),208B=HEADN(PHY)
; ܂LBA擾iLBAΉhCusj
                mov     ax,es:[2300h+(2*61)]    ; 237Ah LBA-High
                mov     dh,al                   ; -->DX
                mov     dl,ah
                mov     ax,es:[2300h+(2*60)]    ; 2378h LBA-Low
                xchg    al,ah           ; DX:AX is LBA
        
                ror     eax,16
                mov     ax,dx
                rol     eax,16          ; EAX <== DX:AX
        
                cmp     byte ptr cs:[0007h],03h
                je      Mode_3_4_A2
                cmp     byte ptr cs:[0007h],04h
                je      Mode_3_4_A2
                mov     word ptr es:[208Eh],0811h
                cmp     dx,0088h
                jb      @f
                mov     cx,es:[208Ah]
                mov     es:[208Eh],cx
    @@:
                jmp     Mode_end_A2

Mode_3_4_A2:    mov     word ptr es:[208Eh],0820h
                cmp     dx,0100h
                jb      @f
                mov     word ptr es:[208Eh],0880h
        @@:

Mode_end_A2:
                PUSH    AX
                test    byte ptr ds:[0457h],10000000b   ; zr=256B/sect 
                jnz     EndTestDrv0_A2
                shl     ax,1    ; 256oCg^ZN^ ̂Ƃ̓V_2{-1
                sal     dx,1
                and     al,0FEh
                mov     word ptr es:[208Eh],0821h ; 256B/sectݒ̂Ƃ 8wbh33ZN^
EndTestDrv0_A2:
                mov     ax,es:[208Eh]  ; D800:208E=SECTN(LGI), 208F=HEADN(LGI)
                mul     ah              ; wbh~ZN^̐
                mov     cx,ax           ; CXɈړA
                POP     AX

                div     cx              ; LBA / (wbh~ZN^̐)

                mov     es:[bx+02h],ax  ;        Cylinder count
                mov     es:[2082h],ax  ;        Cylinder count
                mov     cl,0FFh
                and     ch,0C7h
                or      ch,10h

                PUSH    AX
                mov     ax,es:[208Eh]
                cmp     byte ptr cs:[0007h],1
                je      @f
                cmp     byte ptr cs:[0007h],3
                je      @f
                mov     es:[208Ah],ax
          @@:

                mov     al,6
                out     37h,al
                
                POP     AX

                RET
Patch_DiscriminateCapaA2_END    label   word

; LBA-->CHS ̒u ; Ap=073Dh or BX2=0A26h
PatPtn_CHSLBA_A2 label byte   ; 0A26h
                test    byte ptr [bp+00h],80h
                JNZ     @f
                mov     ax,[bp+04h]
                mov     dx,[bp+06h]    ; $$$
                RET
        @@:
                xor     eax,eax ; eax=0
                mov     ecx,eax ; ecx=0
                mov     ax,word ptr [bp+04h]    ; ax = c
                mov     cl,es:[208Fh]            ; cx = H0
                mul     cx                      ; ax = c*H0
                mov     cl,[bp+06h]             ; cx = H
                add     eax,ecx                 ; eax=(c*H0)+h
                mov     cl,es:[208Eh]           ; cx = S0
                mov     ch,0
                mul     ecx                     ; eax=  { (c*H0)+h }*S0
                movzx   ecx, word ptr [bp+04h]  ; S                
                add     eax,ecx                 ; eax=  { (c*H0)+h }*S0 + S
                rol     eax,16
                mov     dx,ax
                ror     eax,16
                RET
PatPtn_CHSLBA_A2_end   label byte

CodePtn_IDP_A2  label word
        DB      26h,0C6h,06h,00h,20h,07h        ;mov     byte ptr es:[2000],07
        DB      26h,0C6h,06h,01h,20h,00h        ;mov     byte ptr es:[2001],00
        DB      26h,0C6h,06h,0Ah,20h,11h        ;mov     byte ptr es:[200A],11
CodePtn_IDP_A2_end  label word

PatPtn_IDP_A2   label word
                mov     word ptr es:[2000h],07h
                mov     ax,es:[208Ah]
                mov     byte ptr es:[200Ah], al
                mov     al,[bp+00h]
                and     al,0Fh
                shl     al,4
                mov     es:[2004h],al
                or      byte ptr es:[2004h],ah
                nop
PatPtn_IDP_A2_end  label word

CodePtn_Func84  label word
                DB      26h,0Ah,67h,04h         ; or      ah,es:[bx+04]
                DB      0F6h,46h,01h,80h        ;test    byte ptr [bp+01],80
                DB      74h,3Bh                 ;jz     EndF84 ;035A
                DB      80h,0E4h,0F0h           ;and     ah,F0
                DB      26h,0Ah,67h,05h         ;or      ah,es:[bx+05]
                DB      50h                     ;push    ax
                DB      0C7h,46h,02h,00h,01h    ;mov     word ptr [bp+02],0100
                DB      0C6h,46h,06h,21h        ;mov     byte ptr [bp+06],21
                DB      0E8h
                DW      0443h   ;D800:0330 E84304 call    0776
CodePtn_Func84_end  label word

PatPtn_Func84  label word
                DB      26h,0Ah,67h,04h         ;or      ah,es:[bx+04]
                DB      0F6h,46h,01h,80h        ;test    byte ptr [bp+01],80
                DB      74h,3Bh                 ;jz     EndF84 ;035A
                DB      80h,0E4h,0F0h           ;and     ah,F0
                DB      26h,0Ah,67h,05h         ;or      ah,es:[bx+05]
                DB      50h                     ;push    ax
                mov     word ptr [bp+02h],0100h
                DB      0E8h
                DW      0447h   ;call    0776
                jz      @f
                mov     word ptr [bp+02h],0200h
        @@:
                mov     al,es:[208Eh]  ; S
                mov     [bp+06h],al
                mov     al,es:[208Fh]  ; H
                mov     [bp+07h],al
                mov     dx,es:[2082h]  ; C
                mov     [bp+04h],dx
                NOP     ; to 035Ah
PatPtn_Func84_end  label word